/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import org.json.JSONObject;
import org.json.JSONArray;
import pe.siso.academia.DAO.RecuperacionDAO;
import pe.siso.academia.utilities.GeneralVariables;
import pe.siso.academia.utilities.ResponseHelper;

/**
 *
 * @author Felipe Escala
 */
public class MySqlRecuperacionDAO implements RecuperacionDAO {

	@Override
	public JSONObject listarRecuperaciones(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		String condicion = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			if (datos.has("codigoAula")) {
				condicion = " and r.aula_recuperacion = ? ";
			} else if (datos.has("fechaRecuperacion")) {
				condicion = " and fecha_recuperacion = ? ";
			}
			sql = " select  "
				+ " r.codigo_recuperacion, "
				+ " CONCAT_WS(' ',n.nivel,IF(g.grado = 'NORMAL', NULL, g.grado),c.ciclo, t.turno), "
				+ " DATE_FORMAT(r.fecha_recuperacion, '%d/%m/%Y'), "
				+ " r.hora_inicio_recuperacion, "
				+ " r.hora_fin_recuperacion "
				+ " from recuperaciones as r  "
				+ " inner join aula as a  "
				+ " on a.codAula = r.aula_recuperacion "
				+ " inner join academia_grado as g "
				+ " on g.idgrado = a.codTipoGrado "
				+ " inner join academia_nivel as n "
				+ " on a.codNivel = n.idnivel "
				+ " inner join academia_ciclo as c "
				+ " on c.idciclo = a.codGrado "
				+ " inner join academia_turno as t "
				+ " on t.idturno = a.codTurno "
				+ " where r.estado_registro = 1 "
				+ " and a.codSede = ? " + condicion
				+ " limit ?,? ";
			pst = con.prepareStatement(sql);
			int c = 1;
			pst.setInt(c++, datos.getInt("codigoSede"));
			if (datos.has("codigoAula")) {
				pst.setInt(c++, datos.getInt("codigoAula"));
			} else if (datos.has("fechaRecuperacion")) {
				pst.setString(c++, datos.getString("fechaRecuperacion"));
			}
			pst.setInt(c++, datos.getInt("start"));
			pst.setInt(c++, datos.getInt("length"));
			rSet = pst.executeQuery();
			int conta = datos.getInt("start") + 1;
			while (rSet.next()) {
				c = 1;
				JSONObject obj = new JSONObject();
				obj.put("numeral", conta++);
				obj.put("codigoRecuperacion", rSet.getInt(c++));
				obj.put("nombreCiclo", rSet.getString(c++));
				obj.put("fechaRecuperacion", rSet.getString(c++));
				obj.put("inicioRecuperacion", rSet.getString(c++));
				obj.put("finRecuperacion", rSet.getString(c++));
				lista.put(obj);
			}
			sql = " select  "
				+ " count(*) "
				+ " from recuperaciones as r  "
				+ " inner join aula as a  "
				+ " on a.codAula = r.aula_recuperacion "
				+ " inner join academia_grado as g "
				+ " on g.idgrado = a.codTipoGrado "
				+ " inner join academia_nivel as n "
				+ " on a.codNivel = n.idnivel "
				+ " inner join academia_ciclo as c "
				+ " on c.idciclo = a.codGrado "
				+ " inner join academia_turno as t "
				+ " on t.idturno = a.codTurno "
				+ " where r.estado_registro = 1 "
				+ " and a.codSede = ? " + condicion;
			pst = con.prepareStatement(sql);
			c = 1;
			pst.setInt(c++, datos.getInt("codigoSede"));
			if (datos.has("codigoAula")) {
				pst.setInt(c++, datos.getInt("codigoAula"));
			} else if (datos.has("fechaRecuperacion")) {
				pst.setString(c++, datos.getString("fechaRecuperacion"));
			}
			rSet = pst.executeQuery();
			rSet.next();
			rs = rSet.getInt(1);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		jreturn.put("data", lista);
		jreturn.put("recordsFiltered", rs);
		jreturn.put("recordsTotal", rs);
		jreturn.put("draw", datos.getInt("draw"));
		return jreturn;
	}

	@Override
	public JSONObject eliminarRecuperacion(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			con.setAutoCommit(false);
			sql = " update recuperaciones set estado_registro = 0 where codigo_recuperacion = ? ";
			pst = con.prepareStatement(sql);
			pst.setInt(1, datos.getInt("codigoRecuperacion"));
			rs = pst.executeUpdate();
			if (rs != 1) {
				response.setStatus(false);
				response.setMessage("Error al eliminar la recuperacion");
			} else {
				response.setStatus(true);
				response.setMessage("Recuperacion correctamente eliminada");
				con.commit();
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject nuevaRecuperacion(JSONObject datos) throws Exception {
		System.out.println("DATA ---> " + datos);
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			con.setAutoCommit(false);
			data = validarCruceRecuperacion(datos);
			if (data.getBoolean("status")) {
				sql = " INSERT INTO recuperaciones ( "
					+ "	aula_recuperacion, "
					+ "	fecha_recuperacion, "
					+ "	hora_inicio_recuperacion, "
					+ "	hora_fin_recuperacion "
					+ ") "
					+ "VALUES "
					+ "	(?, STR_TO_DATE(?, '%d/%m/%Y'), ?, ?) ";
				pst = con.prepareStatement(sql);
				int c = 1;
				pst.setInt(c++, datos.getInt("codigoCiclo"));
				pst.setString(c++, datos.getString("fechaRecuperacion"));
				pst.setString(c++, datos.getString("inicioRecuperacion"));
				pst.setString(c++, datos.getString("finRecuperacion"));
				rs = pst.executeUpdate();
				if (rs == 1) {
					con.commit();
					response.setStatus(true);
					response.setMessage("Recuperacion correctamente registrada");
				} else {
					response.setStatus(false);
					response.setMessage("Error al registrar recuperación");
				}
			} else {
				response.setStatus(false);
				response.setMessage("Hay cruces de clases");
				response.setResults(data.getJSONArray("results"));
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarCiclos(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			con.setAutoCommit(false);
			sql = " select  "
				+ "a.codAula, "
				+ "CONCAT_WS(' ',n.nivel,IF(g.grado = 'NORMAL', NULL, g.grado),c.ciclo, t.turno) "
				+ "from aula as a  "
				+ "inner join academia_grado as g "
				+ "on g.idgrado = a.codTipoGrado "
				+ "inner join academia_nivel as n "
				+ "on a.codNivel = n.idnivel "
				+ "inner join academia_ciclo as c "
				+ "on c.idciclo = a.codGrado "
				+ "inner join academia_turno as t "
				+ "on t.idturno = a.codTurno "
				+ "WHERE DATE(NOW()) BETWEEN a.fechaInicio AND a.fechaTermino "
				+ "AND a.codSede = ? ";
			pst = con.prepareStatement(sql);
			pst.setInt(1, datos.getInt("codigoSede"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				int c = 1;
				JSONObject obj = new JSONObject();
				obj.put("codigoCiclo", rSet.getInt(c++));
				obj.put("nombreCiclo", rSet.getString(c++));
				lista.put(obj);
			}
			if (lista.length() >= 1) {
				response.setStatus(true);
				response.setMessage("Consulta correcta");
				response.setResults(lista);
			} else {
				response.setStatus(false);
				response.setMessage("No hay contenido");
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject editarRecuperacion(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			con.setAutoCommit(false);
			data = validarCruceRecuperacion(datos);
			if (data.getBoolean("status")) {
				sql = " update recuperaciones  "
					+ "set  "
					+ "	fecha_recuperacion = STR_TO_DATE(?, '%d/%m/%Y'), "
					+ "	hora_inicio_recuperacion = ?, "
					+ "	hora_fin_recuperacion = ? "
					+ "where codigo_recuperacion = ? ";
				pst = con.prepareStatement(sql);
				int c = 1;
				pst.setString(c++, datos.getString("fechaRecuperacion"));
				pst.setString(c++, datos.getString("inicioRecuperacion"));
				pst.setString(c++, datos.getString("finRecuperacion"));
				pst.setInt(c++, datos.getInt("codigoRecuperacion"));
				rs = pst.executeUpdate();
				if (rs == 1) {
					response.setStatus(true);
					response.setMessage("Recuperacion modificada correctamente");
				} else {
					response.setStatus(false);
					response.setMessage("Error al modificar la recuperacion");
				}
			} else {
				response.setStatus(false);
				response.setMessage("Hay cruces de clases");
				response.setResults(data.getJSONArray("results"));
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	private JSONObject validarCruceRecuperacion(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			sql = " SELECT  "
				+ "	b.hora_inicio_bloque, "
				+ "	b.hora_fin_bloque "
				+ " FROM	aula AS a "
				+ " INNER JOIN horarios AS h ON h.codigo_horario = a.codigo_horario "
				+ " INNER JOIN bloques AS b ON b.codigo_horario = a.codigo_horario "
				+ " WHERE a.codAula = ? "
				+ " AND b.dia_bloque = DAYOFWEEK(STR_TO_DATE(?, '%d/%m/%Y')) - 1 "
				+ " AND ((? >= b.hora_inicio_bloque and ? < b.hora_fin_bloque)	 "
				+ "			OR (? > b.hora_inicio_bloque and ? <= b.hora_fin_bloque)	 "
				+ "			OR (? < b.hora_inicio_bloque and ? > b.hora_fin_bloque)) "
				+ " UNION ALL "
				+ " SELECT  "
				+ "	r.hora_inicio_recuperacion, "
				+ "	r.hora_fin_recuperacion "
				+ " FROM recuperaciones AS r "
				+ " INNER JOIN aula AS a ON a.codAula = r.aula_recuperacion "
				+ " WHERE a.codAula = ? "
				+ " AND r.fecha_recuperacion = STR_TO_DATE(?, '%d/%m/%Y') "
				+ " AND ((? >= r.hora_inicio_recuperacion and ? < r.hora_fin_recuperacion) "
				+ " OR (? > r.hora_inicio_recuperacion and ? <= r.hora_fin_recuperacion)	 "
				+ " OR (? < r.hora_inicio_recuperacion and ? > r.hora_fin_recuperacion)); ";
			pst = con.prepareStatement(sql);
			int c = 1;
			pst.setInt(c++, datos.getInt("codigoCiclo"));
			pst.setString(c++, datos.getString("fechaRecuperacion"));
			pst.setString(c++, datos.getString("inicioRecuperacion"));
			pst.setString(c++, datos.getString("inicioRecuperacion"));
			pst.setString(c++, datos.getString("finRecuperacion"));
			pst.setString(c++, datos.getString("finRecuperacion"));
			pst.setString(c++, datos.getString("inicioRecuperacion"));
			pst.setString(c++, datos.getString("finRecuperacion"));
			pst.setInt(c++, datos.getInt("codigoCiclo"));
			pst.setString(c++, datos.getString("fechaRecuperacion"));
			pst.setString(c++, datos.getString("inicioRecuperacion"));
			pst.setString(c++, datos.getString("inicioRecuperacion"));
			pst.setString(c++, datos.getString("finRecuperacion"));
			pst.setString(c++, datos.getString("finRecuperacion"));
			pst.setString(c++, datos.getString("inicioRecuperacion"));
			pst.setString(c++, datos.getString("finRecuperacion"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("horaInicio", rSet.getString(1));
				obj.put("horaFin", rSet.getString(2));
				lista.put(obj);
			}
			if (lista.length() >= 1) {
				response.setStatus(false);
				response.setResults(lista);
			} else {
				response.setStatus(true);
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

}
