/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import org.json.JSONObject;
import org.json.JSONArray;
import pe.siso.academia.DAO.AsistenciaDAO;
import pe.siso.academia.utilities.GeneralVariables;
import pe.siso.academia.utilities.ResponseHelper;

/**
 *
 * @author Felipe Escala
 */
public class MysqlAsistenciaDAO implements AsistenciaDAO {

	@Override
	public JSONObject listarAsistencia(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		String condicion = "";
		int c = 1;
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			if (datos.has("documentoEstudiante")) {
				condicion += " AND e.codestudiante = ? ";
			}
			if (datos.has("cicloEstudiante")) {
				condicion += " AND a.codigo_aula = ? ";
			}
			if (datos.has("rangoInicioAsistencia") && datos.has("rangoFinAsistencia")) {
				condicion += " AND a.fecha_asistencia BETWEEN STR_TO_DATE(?,'%d/%m/%Y') AND STR_TO_DATE(?,'%d/%m/%Y') ";
			}
			if (datos.has("estadoAsistencia")) {
				condicion += " AND a.estado_asistencia = ?	";
			}
			sql = " SELECT "
				+ "	a.codigo_asistencia, "
				+ "	CONCAT_WS(' ',n.nivel,IF(g.grado = 'NORMAL',NULL,g.grado),ca.ciclo,t.turno), "
				+ "	CONCAT_WS(' ',e.paterno,e.materno,e.nombres), "
				+ "	DATE_FORMAT(a.fecha_asistencia,'%d/%m/%Y'), "
				+ "	a.ingreso_asistencia, "
				+ "	IFNULL(a.observacion_asistencia, ''), "
				+ "	a.estado_asistencia,"
				+ "	e.dni, "
				+ "    a.hora_ingreso, "
				+ "    a.hora_salida "
				+ " FROM "
				+ "	asistencias AS a "
				+ " INNER JOIN estudiante AS e ON e.codestudiante = a.codigo_estudiante "
				+ " INNER JOIN aula AS c ON c.codAula = a.codigo_aula "
				+ " INNER JOIN academia_grado AS g ON g.idgrado = c.codTipoGrado "
				+ " INNER JOIN academia_nivel AS n ON c.codNivel = n.idnivel "
				+ " INNER JOIN academia_ciclo AS ca ON ca.idciclo = c.codGrado "
				+ " INNER JOIN academia_turno AS t ON t.idturno = c.codTurno "
				+ " WHERE a.estado_registro = 1 "
				+ " AND e.codsede = ? " + condicion
				+ " ORDER BY 1 desc "
				+ " LIMIT ?,? ";
			pst = con.prepareStatement(sql);
			pst.setInt(c++, datos.getInt("codigoSede"));
			if (datos.has("documentoEstudiante")) {
				pst.setInt(c++, datos.getInt("documentoEstudiante"));
			}
			if (datos.has("cicloEstudiante")) {
				pst.setInt(c++, datos.getInt("cicloEstudiante"));
			}
			if (datos.has("rangoInicioAsistencia") && datos.has("rangoFinAsistencia")) {
				pst.setString(c++, datos.getString("rangoInicioAsistencia"));
				pst.setString(c++, datos.getString("rangoFinAsistencia"));
			}
			if (datos.has("estadoAsistencia")) {
				pst.setInt(c++, datos.getInt("estadoAsistencia"));
			}
			pst.setInt(c++, datos.getInt("start"));
			pst.setInt(c++, datos.getInt("length"));
			rSet = pst.executeQuery();
			int conta = datos.getInt("start") + 1;
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				c = 1;
				obj.put("numeral", conta++);
				obj.put("codigoAsistencia", rSet.getInt(c++));
				obj.put("nombreCiclo", rSet.getString(c++));
				obj.put("nombreEstudiante", rSet.getString(c++));
				obj.put("fechaAsistencia", rSet.getString(c++));
				obj.put("horaAsistencia", rSet.getString(c++));
				obj.put("observacionAsistencia", rSet.getString(c++));
				obj.put("estadoAsistencia", rSet.getInt(c++));
				obj.put("dniEstudiante", rSet.getInt(c++));
				obj.put("horaInicio", rSet.getString(c++));
				obj.put("horaSalida", rSet.getString(c++));
				lista.put(obj);
			}
			sql = " SELECT "
				+ "	COUNT(*) "
				+ " FROM "
				+ "	asistencias AS a "
				+ " INNER JOIN estudiante AS e ON e.codestudiante = a.codigo_estudiante "
				+ " INNER JOIN aula AS c ON c.codAula = a.codigo_aula "
				+ " INNER JOIN academia_grado AS g ON g.idgrado = c.codTipoGrado "
				+ " INNER JOIN academia_nivel AS n ON c.codNivel = n.idnivel "
				+ " INNER JOIN academia_ciclo AS ca ON ca.idciclo = c.codGrado "
				+ " INNER JOIN academia_turno AS t ON t.idturno = c.codTurno "
				+ " WHERE a.estado_registro = 1 "
				+ " AND e.codsede = ? " + condicion;
			pst = con.prepareStatement(sql);
			c = 1;
			pst.setInt(c++, datos.getInt("codigoSede"));
			if (datos.has("documentoEstudiante")) {
				pst.setInt(c++, datos.getInt("documentoEstudiante"));
			}
			if (datos.has("cicloEstudiante")) {
				pst.setInt(c++, datos.getInt("cicloEstudiante"));
			}
			if (datos.has("rangoInicioAsistencia") && datos.has("rangoFinAsistencia")) {
				pst.setString(c++, datos.getString("rangoInicioAsistencia"));
				pst.setString(c++, datos.getString("rangoFinAsistencia"));
			}
			if (datos.has("estadoAsistencia")) {
				pst.setInt(c++, datos.getInt("estadoAsistencia"));
			}
			rSet = pst.executeQuery();
			rSet.next();
			rs = rSet.getInt(1);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		jreturn.put("data", lista);
		jreturn.put("recordsFiltered", rs);
		jreturn.put("recordsTotal", rs);
		jreturn.put("draw", datos.getInt("draw"));
		return jreturn;
	}

	@Override
	public JSONObject editarAsistencias(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			con.setAutoCommit(false);
			sql = " update asistencias "
				+ " set "
				+ " observacion_asistencia = ?, "
				+ " estado_asistencia = ? "
				+ " where codigo_asistencia = ? ";
			pst = con.prepareStatement(sql);
			int c = 1;
			pst.setString(c++, datos.getString("observacionAsistencia"));
			pst.setInt(c++, datos.getInt("estadoAsistencia"));
			pst.setInt(c++, datos.getInt("codigoAsistencia"));
			rs = pst.executeUpdate();
			if (rs == 1) {
				con.commit();
				response.setStatus(true);
				response.setMessage("Asistencia correctamente modificada");
			} else {
				response.setStatus(false);
				response.setMessage("Ocurrio un error al modificar la Asistencia");
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject registrarAsistencia(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			con.setAutoCommit(false);
			sql = " select b.hora_inicio_bloque, b.hora_fin_bloque from aula as a  "
				+ "inner join horarios as h "
				+ "on h.codigo_horario = a.codigo_horario "
				+ "inner join bloques as b  "
				+ "on b.codigo_horario = h.codigo_horario "
				+ "and b.dia_bloque = DAYOFWEEK(STR_TO_DATE(?,'%d/%m/%Y'))- 1 "
				+ "where a.codAula = ? ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("fechaAsistencia"));
			pst.setInt(2, datos.getInt("codigoCiclo"));
			rSet = pst.executeQuery();
			if (rSet.next()) {
				data.put("horaInicio", rSet.getString(1));
				data.put("horaFin", rSet.getString(2));
			}
			sql = " INSERT INTO asistencias ( "
				+ "	codigo_aula, "
				+ "	codigo_estudiante, "
				+ "	dia_asistencia, "
				+ "	fecha_asistencia, "
				+ "	hora_ingreso, "
				+ "	hora_salida, "
				+ "	ingreso_asistencia, "
				+ "	observacion_asistencia, "
				+ "	estado_asistencia "
				+ ") "
				+ "VALUES "
				+ "	( "
				+ "		?, "
				+ "		?, "
				+ "		DAYOFWEEK(STR_TO_DATE(?,'%d/%m/%Y'))- 1, "
				+ "		STR_TO_DATE(?,'%d/%m/%Y'), "
				+ "		?, "
				+ "		?, "
				+ "		?, "
				+ "		?, "
				+ "		CASE "
				+ "			WHEN TIME(?) > TIME(?) THEN 2 "
				+ "			WHEN TIME(?) <= TIME(?) THEN 1 "
				+ "			WHEN TIME(?) = TIME('00:00:00') THEN  0 "
				+ "		END  "
				+ "	); ";
			pst = con.prepareStatement(sql);
			int c = 1;
			pst.setInt(c++, datos.getInt("codigoCiclo"));
			pst.setInt(c++, datos.getInt("codigoEstudiante"));
			pst.setString(c++, datos.getString("fechaAsistencia"));
			pst.setString(c++, datos.getString("fechaAsistencia"));
			pst.setString(c++, data.getString("horaInicio"));
			pst.setString(c++, data.getString("horaFin"));
			pst.setString(c++, datos.getString("horaIngreso"));
			pst.setString(c++, datos.getString("observacionAsistencia"));
			pst.setString(c++, datos.getString("horaIngreso"));
			pst.setString(c++, data.getString("horaInicio"));
			pst.setString(c++, datos.getString("horaIngreso"));
			pst.setString(c++, data.getString("horaInicio"));
			pst.setString(c++, datos.getString("horaIngreso"));
			rs = pst.executeUpdate();

			if (rs == 1) {
				con.commit();
				response.setStatus(true);
				response.setMessage("Asistencia correctamente registrada");
			} else {
				response.setStatus(false);
				response.setMessage("Ocurrió un error al registrar Asistencia");
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject eliminarAsistencia(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			con.setAutoCommit(false);
			sql = " update asistencias  "
				+ " set estado_registro = 0 "
				+ " where codigo_asistencia = ?  ";
			pst = con.prepareStatement(sql);
			pst.setInt(1, datos.getInt("codigoAsistencia"));
			rs = pst.executeUpdate();
			if (rs == 1) {
				con.commit();
				response.setStatus(true);
				response.setMessage("Asistencia correctamente eliminada");
			} else {
				response.setStatus(false);
				response.setMessage("Ocurrió un error al eliminar Asistencia");
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarCicloPorEstudiante(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			sql = " select   "
				+ "	a.codAula,  "
				+ "	CONCAT_WS(' ',n.nivel,IF(g.grado = 'NORMAL', NULL, g.grado),c.ciclo, t.turno)  "
				+ "	from aula as a   "
				+ "	inner join academia_grado as g  "
				+ "	on g.idgrado = a.codTipoGrado  "
				+ "	inner join academia_nivel as n "
				+ "	on a.codNivel = n.idnivel  "
				+ "	inner join academia_ciclo as c  "
				+ "	on c.idciclo = a.codGrado  "
				+ "	inner join academia_turno as t  "
				+ "	on t.idturno = a.codTurno  "
				+ "	inner join matricula as m "
				+ "	on m.codAula = a.codAula "
				+ "	WHERE DATE(NOW()) BETWEEN a.fechaInicio AND a.fechaTermino  "
				+ "	AND a.codSede = ? "
				+ "	and m.cod_estud_matri = ? ";
			pst = con.prepareStatement(sql);
			pst.setInt(1, datos.getInt("codigoSede"));
			pst.setInt(2, datos.getInt("codigoEstudiante"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("codigoCiclo", rSet.getInt(1));
				obj.put("nombreCiclo", rSet.getString(2));
				lista.put(obj);
			}
			if (lista.length() >= 1) {
				response.setStatus(true);
				response.setResults(lista);
			} else {
				response.setStatus(false);
				response.setMessage("El estudiante no está matriculado en ningún ciclo vigente");
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarEstudiantesPorCiclo(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			sql = "";
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarClasesPorCiclo(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			sql = "  	SELECT "
				+ "		DAYOFMONTH(DATE_ADD(CONCAT_WS('-', YEAR(NOW()), ?, '01'),INTERVAL ta. ROW DAY)), "
				+ "		DAYOFWEEK (DATE_ADD(CONCAT_WS('-', YEAR(NOW()), ?, '01'),INTERVAL ta. ROW DAY)) -1, "
				+ "		DATE_ADD(CONCAT_WS('-', YEAR(NOW()), ?, '01'),INTERVAL ta. ROW DAY) "
				+ "	FROM "
				+ "		( "
				+ "			SELECT @ROW := @ROW + 1 AS ROW "
				+ "			FROM INFORMATION_SCHEMA. COLUMNS, "
				+ "				(SELECT @ROW := - 1) t "
				+ "		) Ta "
				+ "	WHERE	Ta. ROW < DAYOFMONTH( "
				+ "			LAST_DAY(CONCAT_WS('-', YEAR(NOW()), ?, '01'))) "
				+ "	 AND DAYOFWEEK(DATE_ADD(CONCAT_WS('-', YEAR(NOW()), ?, '01'), INTERVAL row DAY)) - 1  IN  "
				+ "	( "
				+ "		SELECT	 "
				+ "			b.dia_bloque "
				+ "		FROM "
				+ "			bloques AS b "
				+ "		INNER JOIN horarios AS h ON h.codigo_horario = b.codigo_horario "
				+ "		INNER JOIN aula AS a ON a.codigo_horario = h.codigo_horario "
				+ "		WHERE a.codAula = ?  "
				+ "	); "
				+ "";
			pst = con.prepareStatement(sql);
			int c = 1;
			pst.setString(c++, datos.getString("mesReporte"));
			pst.setString(c++, datos.getString("mesReporte"));
			pst.setString(c++, datos.getString("mesReporte"));
			pst.setString(c++, datos.getString("mesReporte"));
			pst.setString(c++, datos.getString("mesReporte"));
			pst.setInt(c++, datos.getInt("codigoCiclo"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("dayMonth", rSet.getInt(1));
				obj.put("dayWeek", rSet.getInt(2));
				obj.put("date", rSet.getString(3));
				lista.put(obj);
			}
			if (lista.length() >= 1) {
				response.setStatus(true);
				response.setResults(lista);
			} else {
				response.setStatus(false);
				response.setMessage("No hay contenido");
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

}
