/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.json.JSONObject;
import pe.siso.academia.Beans.Usuario;
import pe.siso.academia.Services.PermisosService;

/**
 *
 * @author Felipe Escala
 */
public class ServletPermiso extends HttpServlet {

	@Override
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String param = request.getParameter("accion");
		if (null != param) {
			switch (param) {
				case "listarPermisos":
					listarPermisos(request, response);
					break;
				case "listarEstudiantes":
					listarEstudiantes(request, response);
					break;
				case "registrarPermisos":
					registrarPermisos(request, response);
					break;
				case "eliminarPermiso":
					eliminarPermiso(request, response);
					break;
				case "editarPermiso":
					editarPermiso(request, response);
					break;
				default:
					break;
			}
		}
	}

	private void listarPermisos(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		String jsonString = request.getParameter("json");
		HttpSession session_actual = request.getSession(true);
		Usuario usuario = (Usuario) session_actual.getAttribute("usuario");
		JSONObject json = new JSONObject(jsonString);
		json.put("draw", Integer.parseInt(request.getParameter("draw")));
		json.put("length", Integer.parseInt(request.getParameter("length")));
		json.put("start", Integer.parseInt(request.getParameter("start")));
		json.put("codigoSede", usuario.getCodigoSede());
		PermisosService srv = new PermisosService();
		JSONObject rs = srv.listarPermisos(json);
		out.println(rs);
	}

	private void listarEstudiantes(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		PermisosService srv = new PermisosService();
		HttpSession session_actual = request.getSession(true);
		Usuario usuario = (Usuario) session_actual.getAttribute("usuario");
		JSONObject rs = srv.listarEstudiantes(
			new JSONObject()
				.put("search", request.getParameter("search"))
				.put("page", request.getParameter("page"))
				.put("codigoSede", usuario.getCodigoSede())
		);
		out.println(rs);
	}

	private void registrarPermisos(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		PermisosService srv = new PermisosService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.registrarPermisos(json);
		out.println(rs);
	}

	private void eliminarPermiso(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		PermisosService srv = new PermisosService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.eliminarPermiso(json);
		out.println(rs);
	}

	private void editarPermiso(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		PermisosService srv = new PermisosService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.editarPermiso(json);
		out.println(rs);
	}

}
